/*#############################################################
Name: Niceforms
Version: 2.0
Author: Lucian Slatineanu
URL: http://www.emblematiq.com/projects/niceforms/

Feel free to use and modify but please keep this copyright intact.
#################################################################*/

include(applicationRoot+'common/scripts/calendar.js'); 

//Theme Variables - edit these to match your theme
var imagesPath = "../common/images/";
var selectRightWidthSimple = 19;
var selectRightWidthScroll = 2;
var selectMaxHeight = 200;
var textareaTopPadding = 13;
var textareaSidePadding = 10;
var multiselectTopPadding = 15;
var multiselectSidePadding = 10;
var started = false;

//Global Variables
var NF = new Array();
var isIE = false;
var resizeTest = 1;

var checkmessages= new Array();
checkmessages['Empty']="Required field is empty";
checkmessages['Unselected']="Required field is unselected";
checkmessages['InvalidDate']="Invalid date";
checkmessages['InvalidDateFormat']="Invalid date format";
checkmessages['InvalidFloat']="Invalid float";
checkmessages['InvalidInteger']="Invalid integer";
checkmessages['TooShortString']="The string is too short";
checkmessages['TooLongString']="The string is too long";


function include(filename) {
	var head = document.getElementsByTagName('head')[0];	
	script = document.createElement('script');
	script.src = filename;
	script.type = 'text/javascript';	
	head.appendChild(script);
}

//Initialization function
function NFInit() {
	started = true;
	try {
	  document.execCommand('BackgroundImageCache', false, true);
	} catch(e) {}
	if(!document.getElementById) {return false;}

	NFDo('start');
}

function NFDo(what) {
	var niceforms = document.getElementsByTagName('form');
	var identifier = new RegExp('(^| )'+'niceform'+'( |$)');
	if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
		var ieversion=new Number(RegExp.$1);
		if(ieversion < 7) {return false;} //exit script if IE6
		if(ieversion == 8) isIE = true;
	}

	for(var q = 0; q < niceforms.length; q++) {
	 if(identifier.test(niceforms[q].className)) {
		if(what == "start") { //Load Niceforms
			NF[q] = new niceform(niceforms[q]);
			niceforms[q].start();
		} else { //Unload Niceforms
		    niceforms[q].unload();
			NF[q] = "";
		}
	}}
}

function NFFix() {
	if (started) {
	  NFDo('stop');
	  NFDo('start');
	}
}

function niceform(nf) {

	nf._inputText = new Array(); nf._inputRadio = new Array(); nf._inputCheck = new Array(); nf._inputSubmit = new Array(); nf._inputFile = new Array(); nf._textarea = new Array(); nf._select = new Array(); nf._multiselect = new Array();
	nf.add_inputText = function(obj) {this._inputText[this._inputText.length] = obj; inputText(obj);};
	nf.add_inputSubmit = function(obj) {this._inputSubmit[this._inputSubmit.length] = obj; inputSubmit(obj);};
	nf.add_inputFile = function(obj) {this._inputFile[this._inputFile.length] = obj; inputFile(obj);};
	nf.add_textarea = function(obj) {this._textarea[this._textarea.length] = obj; textarea(obj);};
	nf.add_select = function(obj) {this._select[this._select.length] = obj; selects(obj);};
	nf.add_multiselect = function(obj) {this._multiselect[this._multiselect.length] = obj; multiSelects(obj);};
	nf.add_inputRadio = function(obj) {this._inputRadio[this._inputRadio.length] = obj; inputRadio(obj);};
	nf.add_inputCheck = function(obj) {this._inputCheck[this._inputCheck.length] = obj; inputCheck(obj);};
	nf.start = function() {
		//Separate and assign elements
		var allInputs = this.getElementsByTagName('input');
		for(var w = 0; w < allInputs.length; w++) {
			switch(allInputs[w].type) {
				case "text": case "password": {this.add_inputText(allInputs[w]); break;}
				case "submit": case "reset": case "button": {this.add_inputSubmit(allInputs[w]); break;}
				case "file": {this.add_inputFile(allInputs[w]); break;}
			}
		}
		var allButtons = this.getElementsByTagName('button');
		for(var w = 0; w < allButtons.length; w++) {
			this.add_inputSubmit(allButtons[w]);
		}
		var allTextareas = this.getElementsByTagName('textarea');
		for(var w = 0; w < allTextareas.length; w++) {
			this.add_textarea(allTextareas[w]);
		}
		var allSelects = this.getElementsByTagName('select');
		for(var w = 0; w < allSelects.length; w++) {
			if(!allSelects[w].size || allSelects[w].size == "1") {this.add_select(allSelects[w]);}
			else {this.add_multiselect(allSelects[w]);}
		}

		//Start
		for(w = 0; w < this._inputText.length; w++) {this._inputText[w].init();}
		for(w = 0; w < this._inputSubmit.length; w++) {this._inputSubmit[w].init();}
		for(w = 0; w < this._inputFile.length; w++) {this._inputFile[w].init();}
		for(w = 0; w < this._textarea.length; w++) {this._textarea[w].init();}
		for(w = 0; w < this._select.length; w++) {this._select[w].init(w);}
		for(w = 0; w < this._multiselect.length; w++) {this._multiselect[w].init(w);}

        for(var w = 0; w < allInputs.length; w++) {
			switch(allInputs[w].type) {
				case "radio": {this.add_inputRadio(allInputs[w]); break;}
				case "checkbox": {this.add_inputCheck(allInputs[w]); break;}
			}
		}

		for(w = 0; w < this._inputRadio.length; w++) {this._inputRadio[w].init();}
		for(w = 0; w < this._inputCheck.length; w++) {this._inputCheck[w].init();}

		window.onresize = function() {
			if(resizeTest != (document.documentElement.clientWidth+document.documentElement.clientHeight)) {
				existingResizeEvent();
				resizeTest = (document.documentElement.clientWidth+document.documentElement.clientHeight);
				NFFix();
			}
        };
	};
	nf.unload = function() {
		//Stop
        for(var w = 0; w < this._inputText.length; w++) {this._inputText[w].unload();}
		for(w = 0; w < this._inputSubmit.length; w++) {this._inputSubmit[w].unload();}
		for(w = 0; w < this._inputFile.length; w++) {this._inputFile[w].unload();}
		for(w = 0; w < this._textarea.length; w++) {this._textarea[w].unload();}
		for(w = 0; w < this._select.length; w++) {this._select[w].unload();}
		for(w = 0; w < this._multiselect.length; w++) {this._multiselect[w].unload();}
		for(w = 0; w < this._inputRadio.length; w++) {this._inputRadio[w].unload();}
		for(w = 0; w < this._inputCheck.length; w++) {this._inputCheck[w].unload();}

		window.onresize = function() {};
	};
};



function inputText(el) { //extent Text inputs
	el.oldClassName = el.className;
	if (!el.style.width) {
	  el.style.width =  el.offsetWidth + 'px';
	}

	if ( el.getAttribute("picker") && el.getAttribute("picker")=="date" ) {
		el.button = document.createElement('img');
		el.button.src = imagesPath + "0.png";
		el.button.className = "NFDateButton";
		el.button.ref = el;
		var lang="EN";
		if ( el.getAttribute("datelang") ) { lang= el.getAttribute("datelang"); }
		var format="yyyy-MM-dd";
		if ( el.getAttribute("dateformat") ) { format= el.getAttribute("dateformat"); }
		el.button.onclick = function() {
			if(isIE == false) {	showCalendar(lang,format,el.id); }
			else { showCalendar(lang,format,el.id); }  };
		if (!el.set) {  el.set="true"; el.style.width = getValue(el.style.width) - 19 + 'px' ;  }
	} else if ( el.getAttribute("picker") && el.getAttribute("picker")=="popup" ) {
		el.button = document.createElement('img');
		el.button.src = imagesPath + "0.png";
		el.button.className = "NFPopButton";
		el.button.ref = el;

		var url="";
		if ( el.getAttribute("url") ) { url= el.getAttribute("url"); }
		
		var popstyle="width=600,height=400, resizable=no,scrollbars=yes";
		if ( el.getAttribute("popstyle") ) { popstyle= el.getAttribute("popstyle"); }
		
		el.button.onclick = function() {
		   if(isIE == false) { showPopUp(url,popstyle,el.id); }
		   else { showPopUp(url,popstyle,el.id);}  
		};
		if (!el.set) {  el.set="true"; el.style.width = getValue(el.style.width) - 19 + 'px' ;  }
	} else{
	    if (!el.set) {  el.set="true"; el.style.width = getValue(el.style.width) - 5 + 'px' ;  }
	}
    el.left = document.createElement('img');
    el.left.src = imagesPath + "0.png";
    el.left.className = "NFTextLeft";
	el.right = document.createElement('img');
	el.right.src = imagesPath + "0.png";
	el.right.className = "NFTextRight";
	el.dummy = document.createElement('div');
	el.dummy.className = "NFTextCenter";
	el.onfocus = function() {
		this.dummy.className = "NFTextCenter NFh";
		this.left.className = "NFTextLeft NFh";
		if (!this.button) { this.right.className = "NFTextRight NFh"; }
	};
	el.onblur = function() { 
		this.dummy.className = "NFTextCenter";
		this.left.className = "NFTextLeft";
		if (!this.button) { this.right.className = "NFTextRight"; }
	};
	el.init = function() {

		var top = this.parentNode;
		var where ;
		if(this.nextSibling) { where = this.nextSibling;}
		else { where = top.childNodes[0];}

		if (this.button) {
			this.parentNode.insertBefore(this.button, where);
			this.parentNode.insertBefore(this.dummy, this.button);
	    } else {
			this.parentNode.insertBefore(this.right, where);
			this.parentNode.insertBefore(this.dummy, this.right);
		}
		this.parentNode.insertBefore(this.left, this.dummy);
		this.dummy.appendChild(this);

		this.className = "NFText";
	};
	el.unload = function() {
		this.parentNode.parentNode.insertBefore(this,this.left);
		this.parentNode.removeChild(this.left);
		if (this.button) {
		   this.parentNode.removeChild(this.button);
		} else {
		   this.parentNode.removeChild(this.right);
		}
		this.parentNode.removeChild(this.dummy);
		this.className = this.oldClassName;
	};
}
function inputRadio(el) { //extent Radio buttons
    el.style.visibility = "hidden";
	el.oldClassName = el.className;
	el.dummy = document.createElement('img');
	el.dummy.src = imagesPath + "0.png";
	if(el.checked) {el.dummy.className = "NFRadio NFh";}
	else {el.dummy.className = "NFRadio";}
	el.dummy.ref = el;
    elclick = el.onclick;

    el.dummy.style.left = findPosX(el)  +  'px';
    el.dummy.style.top = findPosY(el) + 2 + 'px';

	el.dummy.onclick = function() {
		if(!this.ref.checked) {
			var siblings = getInputsByName(this.ref.name);
			for(var q = 0; q < siblings.length; q++) {
				siblings[q].checked = false;
				siblings[q].dummy.className = "NFRadio";
			}
			this.ref.checked = true;
			this.className = "NFRadio NFh";
		} else {
			this.ref.checked = false;
			this.className = "NFRadio";
        }  
        if (el.onclick)  { el.onclick(); } 
	};

	el.onfocus = function() {this.dummy.className += " NFfocused";};
	el.onblur  = function() {this.dummy.className = this.dummy.className.replace(/ NFfocused/g, "");};
	el.init = function() {
		this.parentNode.insertBefore(this.dummy, this);
		el.className = "NFhidden";
	};
	el.unload = function() {
		this.parentNode.removeChild(this.dummy);
		this.className = this.oldClassName;
	};
}
function inputCheck(el) { //extend Checkboxes
    el.style.visibility = "hidden";
	el.oldClassName = el.className;
	el.dummy = document.createElement('img');
	el.dummy.src = imagesPath + "0.png";
	if(el.checked) {el.dummy.className = "NFCheck NFh";}
	else {el.dummy.className = "NFCheck";}
	el.dummy.ref = el;

    el.dummy.style.left = findPosX(el)  +  'px';
    el.dummy.style.top = findPosY(el) + 2 + 'px';

	el.dummy.onclick = function() {
		if(!this.ref.checked) {
			this.ref.checked = true;
			this.className = "NFCheck NFh";
		}
		else {
			this.ref.checked = false;
			this.className = "NFCheck";
		}
        if (el.onclick)  { el.onclick(); } 
	};

	el.onfocus = function() {this.dummy.className += " NFfocused";};
	el.onblur = function() {this.dummy.className = this.dummy.className.replace(/ NFfocused/g, "");};
	el.init = function() {
		this.parentNode.insertBefore(this.dummy, this);
		el.className = "NFhidden";
	};
	el.unload = function() {
		this.parentNode.removeChild(this.dummy);
		this.className = this.oldClassName;
	};
}
function inputSubmit(el) { //extend Buttons
	el.oldClassName = el.className;
	el.left = document.createElement('img');
	el.left.className = "NFButtonLeft";
	el.left.src = imagesPath + "0.png";
	el.right = document.createElement('img');
	el.right.src = imagesPath + "0.png";
	el.right.className = "NFButtonRight";
	el.onmouseover = function() {
		this.className = "NFButton NFh";
		this.left.className = "NFButtonLeft NFh";
		this.right.className = "NFButtonRight NFh";
	};
	el.onmouseout = function() {
		this.className = "NFButton";
		this.left.className = "NFButtonLeft";
		this.right.className = "NFButtonRight";
	};
	el.init = function() {
		this.parentNode.insertBefore(this.left, this);
		this.parentNode.insertBefore(this.right, this.nextSibling);
		this.className = "NFButton";
	};
	el.unload = function() {
		this.parentNode.removeChild(this.left);
		this.parentNode.removeChild(this.right);
		this.className = this.oldClassName;
	};
}
function inputFile(el) { //extend File inputs
	el.oldClassName = el.className;

	if (!el.style.width) {
	  el.style.width =  el.offsetWidth + 'px';
	}

	el.dummy = document.createElement('div');
	el.dummy.className = "NFFile";
	el.dummy.onchange=el.onchange;
	el.file = document.createElement('div');
	el.file.className = "NFFileNew";
	el.center = document.createElement('div');
	el.center.className = "NFTextCenter";
	el.clone = document.createElement('input');
	el.clone.type = "text";
	el.clone.className = "NFText";
	el.clone.ref = el;
	el.clone.style.width=el.style.width;
	el.clone.style.width = getValue(el.style.width) - 58+ 'px' ;
	
	el.left = document.createElement('img');
	el.left.src = imagesPath + "0.png";
	el.left.className = "NFTextLeft";
	el.button = document.createElement('img');
	el.button.src = imagesPath + "0.png";
	el.button.className = "NFFileButton";
	el.button.ref = el;
		
	el.button.onclick = function() {
	    this.ref.click(); 
    };
	el.init = function() {
		var top = this.parentNode;
		var where;
		if(this.previousSibling) { where = this.previousSibling;}
		else { where = top.childNodes[0];}
		top.insertBefore(this.dummy, where);
		this.dummy.appendChild(this);
		this.center.appendChild(this.clone);
		this.file.appendChild(this.center);
		this.file.insertBefore(this.left, this.center);
		this.file.appendChild(this.button);
		this.dummy.appendChild(this.file);
		this.className = "NFhidden";
		this.size = Math.round(( getValue(el.style.width) - 100 )/5) +3 ;
	};
	el.unload = function() {
		this.parentNode.parentNode.appendChild(this);
		this.parentNode.removeChild(this.dummy);
		this.className = this.oldClassName;
	};
	el.onchange = el.onmouseout = function() {
		this.clone.value = this.value.replace("fakepath","..");
		el.dummy.onchange();
	};
	el.onfocus = function() {
		this.left.className = "NFTextLeft NFh";
		this.center.className = "NFTextCenter NFh";
		this.button.className = "NFFileButton NFh";
	};
	el.onblur = function() {
		this.left.className = "NFTextLeft";
		this.center.className = "NFTextCenter";
		this.button.className = "NFFileButton";
	};
	el.onselect = function() {
		this.relatedElement.select();
		this.value = '';
	};
}
	
function textarea(el) { //extend Textareas

	if (!el.style.width) {
	  el.width = el.offsetWidth - textareaSidePadding;
	  el.style.width =  el.width + 'px';
	}

	if (!el.style.height) {
	  el.height = el.offsetHeight - textareaTopPadding;
	  el.style.height = el.height + 'px';
	}

	el.oldClassName = el.className;
	el.topLeft = document.createElement('img');
	el.topLeft.src = imagesPath + "0.png";
	el.topLeft.className = "NFTextareaTopLeft";
	el.topRight = document.createElement('div');
	el.topRight.className = "NFTextareaTop";
	el.bottomLeft = document.createElement('img');
	el.bottomLeft.src = imagesPath + "0.png";
	el.bottomLeft.className = "NFTextareaBottomLeft";
	el.bottomRight = document.createElement('div');
	el.bottomRight.className = "NFTextareaBottom";
	el.left = document.createElement('div');
	el.left.className = "NFTextareaLeft";
	el.right = document.createElement('div');
	el.right.className = "NFTextareaRight";
	el.init = function() {
		var top = this.parentNode;
		var where;
		if(this.previousSibling) { where = this.previousSibling;}
		else { where = top.childNodes[0];}
		top.insertBefore(el.topRight, where);
		top.insertBefore(el.right, where);
		top.insertBefore(el.bottomRight, where);
		this.topRight.appendChild(this.topLeft);
		this.right.appendChild(this.left);
		this.right.appendChild(this);
		this.bottomRight.appendChild(this.bottomLeft);
		el.topRight.style.width = el.bottomRight.style.width = el.style.width;
		el.left.style.height = el.right.style.height = el.style.height;
		this.className = "NFTextarea";
	};
	el.unload = function() {
		this.parentNode.parentNode.insertBefore(this,this.bottomRight);
		this.parentNode.removeChild(this.topRight);
		this.parentNode.removeChild(this.bottomRight);
		this.parentNode.removeChild(this.right);
		this.className = this.oldClassName;
		//this.style.width =
		this.style.height = "";
	};
	el.onfocus = function() {
		this.topLeft.className = "NFTextareaTopLeft NFh";
		this.topRight.className = "NFTextareaTop NFhr";
		this.left.className = "NFTextareaLeftH";
		this.right.className = "NFTextareaRightH";
		this.bottomLeft.className = "NFTextareaBottomLeft NFh";
		this.bottomRight.className = "NFTextareaBottom NFhr";
	};
	el.onblur = function() { 
		this.topLeft.className = "NFTextareaTopLeft";
		this.topRight.className = "NFTextareaTop";
		this.left.className = "NFTextareaLeft";
		this.right.className = "NFTextareaRight";
		this.bottomLeft.className = "NFTextareaBottomLeft";
		this.bottomRight.className = "NFTextareaBottom";
	};
}

function getValue( num ) {
  try {
	if ( num.indexOf("px")>0 ) {
	   return parseInt(num.replace("px",""),10);
	} else {
	   return num ;
	}
  } catch (e) { return num; }
}


function selects(el) { //extend Selects
    el.style.visibility = "hidden";
	el.oldClassName = el.className;
	el.dummy = document.createElement('div');
	el.dummy.className = "NFSelect";
	el.dummy.tabIndex=""; // For Firefox compatibility

	if (!el.style.width) {
	  el.dummy.style.width = el.offsetWidth + 'px';
	} else {
	  el.dummy.style.width = getValue(el.style.width) + 9 + 'px' ;
	}

    
	el.dummy.ref = el;
    el.dummy.changed = false;
	el.left = document.createElement('img');
	el.left.src = imagesPath + "0.png";
	el.left.className = "NFSelectLeft";
	el.right = document.createElement('div');
	el.right.className = "NFSelectRight";

	el.bg = document.createElement('div');
	el.bg.className = "NFSelectTarget";
	el.bg.style.display = "none";
	el.opt = document.createElement('ul');
	el.opt.className = "NFSelectOptions";
	el.dummy.selectedIndex = el.selectedIndex;

	if (el.options.length>0) {
	  el.txt = document.createTextNode(el.options[0].text);
	  el.opts = new Array(el.options.length);
    } else {
	  el.opts = new Array();
	}

	el.init = function(pos) {
		this.dummy.appendChild(this.left);
		this.right.appendChild(this.txt);
		this.dummy.appendChild(this.right);
		this.bg.appendChild(this.opt);
		this.dummy.appendChild(this.bg);
		for(var q = 0; q < this.options.length; q++) {
			this.opts[q] = new option(this.options[q], q);
			this.opt.appendChild(this.options[q].li);
			this.options[q].lnk.onclick = function() {
				this._onclick();
				var txt = this.ref.options[this.pos].text;
				txt=txt.replace('<',"&lt;");
				txt=txt.replace('>',"&gt;");
				this.ref.dummy.getElementsByTagName('div')[0].innerHTML = txt;				
				this.ref.selectedIndex = this.pos ;
				for(var w = 0; w < this.ref.options.length; w++) {this.ref.options[w].lnk.className = "";}
				this.ref.options[this.pos].lnk.className = "NFOptionActive";
				this.selectedIndex=this.pos;
                this.ref.dummy.changed=false;
				if (this.ref.onchange)  this.ref.onchange();
			};
		}
		if(this.options.selectedIndex) {
			var txt = this.options[this.options.selectedIndex].text;
			txt=txt.replace('<',"&lt;");
			txt=txt.replace('>',"&gt;");
			this.dummy.getElementsByTagName('div')[0].innerHTML = txt;
			this.options[this.options.selectedIndex].lnk.className = "NFOptionActive";            
		}
		this.dummy.style.zIndex = 999 - pos;
		this.parentNode.insertBefore(this.dummy, this);
		this.className = "NFhidden";
	};

	el.unload = function() {
		this.parentNode.removeChild(this.dummy);
		this.className = this.oldClassName;
	};
	el.dummy.onclick = function() {

		var allDivs = document.getElementsByTagName('div');
		for(var q = 0; q < allDivs.length; q++) {
			if((allDivs[q].className == "NFSelectTarget") && (allDivs[q] != this.ref.bg)) {
				allDivs[q].style.display = "none";}
		}
		if(this.ref.bg.style.display == "none") {this.ref.bg.style.display = "block";}
		else {this.ref.bg.style.display = "none";}

		if(this.ref.opt.offsetHeight > selectMaxHeight) {
			this.ref.bg.style.width = this.ref.offsetWidth - selectRightWidthScroll + 33 + 'px';
			this.ref.opt.style.width = this.ref.offsetWidth - selectRightWidthScroll + 8 + 'px';
		}
		else {
			this.ref.bg.style.width = this.ref.offsetWidth - selectRightWidthSimple + 33 + 'px';
			this.ref.opt.style.width = this.ref.offsetWidth - selectRightWidthSimple + 8 + 'px';
		}    
		
        this.ref.opt.scrollTop = this.ref.selectedIndex*18;
	};
	el.bg.onmouseout = function(e) {
		if (!e) var e = window.event;
		e.cancelBubble = true;
        try {
			if (e.stopPropagation) e.stopPropagation();
			var reltg = (e.relatedTarget) ? e.relatedTarget : e.toElement;
			if((reltg.nodeName == 'A') || (reltg.nodeName == 'LI') || (reltg.nodeName == 'UL')) return;
			if((reltg.nodeName == 'DIV') || (reltg.className == 'NFSelectTarget')) return;
			else{this.style.display = "none";}
        } catch (ex) {}
	};
	el.dummy.onmouseout = function(e) {
		if (!e) var e = window.event;
		e.cancelBubble = true;
        try {
			if (e.stopPropagation) e.stopPropagation();
			var reltg = (e.relatedTarget) ? e.relatedTarget : e.toElement;
			if((reltg.nodeName == 'A') || (reltg.nodeName == 'LI') || (reltg.nodeName == 'UL')) return;
			if((reltg.nodeName == 'DIV') || (reltg.className == 'NFSelectTarget')) return;
			else{this.ref.bg.style.display = "none";}
       } catch (ex) {}
	};
	el.onfocus = function() { this.dummy.className += " NFfocused";};
	el.onblur = function() { 
		this.dummy.className = this.dummy.className.replace(/ NFfocused/g, "");
	};

	el.dummy.onblur  = function () {       
      if (this.changed) {
		this.ref.selectedIndex = this.selectedIndex ;
        if (this.ref.onchange)  { this.ref.onchange(); }
      }

	};
	el.dummy.onfocusout  = function () { 	
      if (this.changed) {	
   	    this.ref.selectedIndex = this.selectedIndex ;
        if (this.ref.onchange)  { this.ref.onchange(); }
      }			

/*    Ripristina valore precedente
	  var txt = this.ref.options[this.ref.selectedIndex].text;
	  txt=txt.replace('<',"&lt;");
	  txt=txt.replace('>',"&gt;");
	  this.getElementsByTagName('div')[0].innerHTML = txt;*/
	};

	el.dummy.onkeydown = function(e) {
		if (!e) e = window.event;
		var thecode = e.keyCode;
		var active = this.selectedIndex;
		switch(thecode){
			case 40: //down
				if(active < this.ref.options.length - 1) {
					for(var w = 0; w < this.ref.options.length; w++) {this.ref.options[w].lnk.className = "";}
					var newOne = active + 1;
					//this.ref.options[newOne].selected = "selected";
					this.selectedIndex=newOne;
					this.ref.options[newOne].lnk.className = "NFOptionActive";
					this.ref.dummy.getElementsByTagName('div')[0].innerHTML = this.ref.options[newOne].text;
                    this.changed=true;
                    this.ref.opt.scrollTop = (this.selectedIndex)*18;
				}
				break;
			case 38: //up
				if(active > 0) {
					for(var w = 0; w < this.ref.options.length; w++) {this.ref.options[w].lnk.className = "";}
					var newOne = active - 1;
					//this.ref.options[newOne].selected = "selected";
					this.selectedIndex=newOne;
					this.ref.options[newOne].lnk.className = "NFOptionActive";
					this.ref.dummy.getElementsByTagName('div')[0].innerHTML = this.ref.options[newOne].text;
                    this.changed=true;
                    this.ref.opt.scrollTop = (this.selectedIndex)*18;
				}              
				break;
            case 13: //select  
				this.ref.bg.style.display = "none";  
				this.ref.selectedIndex = this.selectedIndex ;
                this.changed=false;
				if (this.ref.onchange)  this.ref.onchange();				
				break;
			default:
                var newOne = active ;
                var charpressed = String.fromCharCode(thecode).toUpperCase();
				var found = 0;
				for(var w = active+1; w < this.ref.options.length; w++) { 
                   if ( this.ref.options[w].text.toUpperCase().indexOf(charpressed)==0 ) {
                       newOne=w;
                       found=1;
                       break;
                   }
			    }
                for(var w = 0; w < this.ref.options.length; w++) { 
                   if ( found==0 && this.ref.options[w].text.toUpperCase().indexOf(charpressed)==0 ) {
                       newOne=w;
                       found=1;
                   }
                   this.ref.options[w].lnk.className = "";
                }
			    this.selectedIndex=newOne;
				this.ref.selectedIndex =newOne;				
			    this.ref.options[newOne].lnk.className = "NFOptionActive";
			    this.ref.dummy.getElementsByTagName('div')[0].innerHTML = this.ref.options[newOne].text;
				this.ref.bg.style.display = "none"; 
                this.changed=true;
				break;
		}		
		return false;
	};
}
function multiSelects(el) { //extend Multiple Selects
	el.oldClassName = el.className;
	el.topLeft = document.createElement('img');
	el.topLeft.src = imagesPath + "0.png";
	el.topLeft.className = "NFMultiSelectTopLeft";
	el.topRight = document.createElement('div');
	el.topRight.className = "NFMultiSelectTop";
	el.bottomLeft = document.createElement('img');
	el.bottomLeft.src = imagesPath + "0.png";
	el.bottomLeft.className = "NFMultiSelectBottomLeft";
	el.bottomRight = document.createElement('div');
	el.bottomRight.className = "NFMultiSelectBottom";
	el.left = document.createElement('div');
	el.left.className = "NFMultiSelectLeft";
	el.right = document.createElement('div');
	el.right.className = "NFMultiSelectRight";
	el.init = function() {
		var top = this.parentNode;
		var where;
		if(this.previousSibling) { where = this.previousSibling;}
		else { where = top.childNodes[0];}
		top.insertBefore(el.topRight, where);
		top.insertBefore(el.right, where);
		top.insertBefore(el.bottomRight, where);
		this.topRight.appendChild(this.topLeft);
		this.right.appendChild(this.left);
		this.right.appendChild(this);
		this.bottomRight.appendChild(this.bottomLeft);
		if (!el.style.width) {
		  el.width = el.offsetWidth - multiselectSidePadding;
		  el.style.width =  el.width + 'px';
		}
		if (!el.style.height) {
		  el.height = el.offsetHeight - multiselectTopPadding;
		  el.style.height = el.height + 'px';
		}
		el.topRight.style.width = el.bottomRight.style.width = el.style.width;
		el.left.style.height = el.right.style.height = el.style.height;
		el.className = "NFMultiSelect";
		
        var iFirstSelect=0;	
		for (var i=0; i<el.options.length; i++) {
			if (el.options[i].selected) {
				iFirstSelect=i; break;
			}
		}
        el.scrollTop = iFirstSelect*18;
	};
	el.unload = function() {
		this.parentNode.parentNode.appendChild(this);
		this.parentNode.removeChild(this.topRight);
		this.parentNode.removeChild(this.bottomRight);
		this.parentNode.removeChild(this.right);
		this.className = this.oldClassName;
		//this.style.width =
		this.style.height = "";
	};
	el.onfocus = function() {
		this.topLeft.className = "NFMultiSelectTopLeft NFh";
		this.topRight.className = "NFMultiSelectTop NFhr";
		this.left.className = "NFMultiSelectLeftH";
		this.right.className = "NFMultiSelectRightH";
		this.bottomLeft.className = "NFMultiSelectBottomLeft NFh";
		this.bottomRight.className = "NFMultiSelectBottom NFhr";
	};
	el.onblur = function() {
		this.topLeft.className = "NFMultiSelectTopLeft";
		this.topRight.className = "NFMultiSelectTop";
		this.left.className = "NFMultiSelectLeft";
		this.right.className = "NFMultiSelectRight";
		this.bottomLeft.className = "NFMultiSelectBottomLeft";
		this.bottomRight.className = "NFMultiSelectBottom";
	};
}
function option(el, no) { //extend Options
	el.li = document.createElement('li');
	el.lnk = document.createElement('a');
	el.lnk.href = "javascript:;";
	el.lnk.ref = el.parentNode;
	el.lnk.pos = no;
	el.lnk._onclick = el.onclick || function () {};
	el.txt = document.createTextNode(el.text);
	el.lnk.appendChild(el.txt);
	el.li.appendChild(el.lnk);
}

//Get Position
function findPosY(obj) {
	var posTop = 0;
	do {posTop += obj.offsetTop;} while (obj = obj.offsetParent);
	return posTop;
}
function findPosX(obj) {
	var posLeft = 0;
	do {posLeft += obj.offsetLeft;} while (obj = obj.offsetParent);
	return posLeft;
}
//Get Siblings
function getInputsByName(name) {
	var inputs = document.getElementsByTagName("input");
	var w = 0; var results = new Array();
	for(var q = 0; q < inputs.length; q++) {if(inputs[q].name == name) {results[w] = inputs[q]; ++w;}}
	return results;
}



//Add events
var existingLoadEvent = window.onload || function () {};
var existingResizeEvent = window.onresize || function() {};

window.onload = function () {
    existingLoadEvent();
    resizeTest = (document.documentElement.clientWidth+document.documentElement.clientHeight);
    NFInit();
};



//####################################################################################

function listbox_move(listID,direction) {
	   var listbox=document.getElementById(listID);
	   var selIndex=listbox.selectedIndex;
	   if(-1==selIndex){
		//alert("Please select an option to move.");
		return;
	   }
	   var increment=-1;
	   if(direction=='up') increment=-1;else increment=1;
	   if((selIndex+increment)<0||(selIndex+increment)>(listbox.options.length-1)){return;}
		var selValue=listbox.options[selIndex].value;
		var selText=listbox.options[selIndex].text;
		listbox.options[selIndex].value=listbox.options[selIndex+increment].value;
		listbox.options[selIndex].text=listbox.options[selIndex+increment].text;
		listbox.options[selIndex+increment].value=selValue;
		listbox.options[selIndex+increment].text=selText;listbox.selectedIndex=selIndex+increment;
	}
		
	function listbox_moveacross(sourceID,destID){
		var src=document.getElementById(sourceID);
		var dest=document.getElementById(destID);
		for(var count=0;count<src.options.length;count++){
			if(src.options[count].selected==true){
				var option=src.options[count];
				var newOption=document.createElement("option");
				newOption.value=option.value;
				newOption.text=option.text;
				newOption.selected=true;
				try {
					dest.add(newOption,null);
					src.remove(count,null);
				} catch(error){
					dest.add(newOption);
					src.remove(count);
				}
				count--;
			}
		}
	}

	function listbox_selectall(listID,isSelect){
		var listbox=document.getElementById(listID);
		for(var count=0;count<listbox.options.length;count++){
			listbox.options[count].selected=isSelect;
		}
	}
	

//####################################################################################

function trimLeft(sString) { 
	while (sString.substring(0,1) == ' ') { 
	   sString = sString.substring(1, sString.length); 
	} 
	return sString; 
} 

function trimRight(sString) { 
	while (sString.substring(sString.length-1, sString.length) == ' ') 	{ 
	   sString = sString.substring(0,sString.length-1); 
	} 
	return sString; 
} 

function trim(sString) { 
    sString = trimLeft(sString); 
    sString = trimRight(sString); 
	return sString; 
} 

function isOpener(s) {
   try {
    if (window.opener != null) {
     if (isIE==true) {
	    window.opener='X';
	    window.open('','_parent','');
     }
	 window.close();
    } else {
      var popup = window.parent.document.getElementById("dwindow");
      if ( popup && popup.style.display=='' ) { 
    	popup.style.display='none';
      }	else {
        self.location = s;
      }
    }
   } catch (e) {
     self.location = s;
   }
}


function showAlertMessage(fieldlabel,message,format) {
    if (!format) { format=""; }
    if (fieldlabel) {
       alert(fieldlabel+":\n"+checkmessages[message]+" "+format);
    } else {
       alert(checkmessages[message]+" "+format);
    }
}

function isDigit (c) {
    return ((c >= "0") && (c <= "9"));
}

function isLetter (c) {
    return (((c >= "a") && (c <= "z")) || ((c >= "A") && (c <= "Z")));
}

function isEmpty(s) {
    if(isNaN(s)){
	  return ((s == null) || (trim(s).length == 0));
    } else {
      return ((s == null) || (trim(s).length == 0) || parseFloat(s)==0);
    }
}

function isInteger(s) {
  var theData = new String(s);
  if (!isDigit(theData.charAt(0))) {
    if (!(theData.charAt(0)== '+') && !(theData.charAt(0)== '-')) return false;
  }
  for (var i = 1; i < theData.length; i++)
    if (!isDigit(theData.charAt(i)))
       return false;
  return true;
}

function isNotEmpty(formname, field, fieldlabel) {
   var form = document.forms[formname];
   try {
     var value = form.elements[field].value;
     if(isEmpty(value)) {
       form.elements[field].focus();
       if (form.elements[field].type) { showAlertMessage(fieldlabel,'Empty',""); }       
       return false;
     }
   } catch (e) {
	   for (var i = 0; i < form.elements.length; i++)  {
		  formelement = form.elements[i];
		  if ( formelement.type=="radio" && formelement.name==field && formelement.checked ) {
			  return true;
		  } else if ( formelement.type=="checkbox" && formelement.name==field+"[]" && formelement.checked ) {
			  return true;
		  }
	   }
       showAlertMessage(fieldlabel,'Unselected',"");
       return false;
   }
   return true;
}

function isNotIgnored(formname, field, fieldlabel) {
   var form = document.forms[formname];
   try {
     var value = form.elements[field].value;
     if(isEmpty(value) || value=="*") {
       form.elements[field].focus();
       if (form.elements[field].type) { showAlertMessage(fieldlabel,'Ignored',""); }       
       return false;
     }
   } catch (e) {
	   for (var i = 0; i < form.elements.length; i++)  {
		  formelement = form.elements[i];
		  if ( formelement.type=="radio" && formelement.name==field && formelement.checked ) {
			  return true;
		  } else if ( formelement.type=="checkbox" && formelement.name==field+"[]" && formelement.checked ) {
			  return true;
		  }
	   }
       showAlertMessage(fieldlabel,'Ignored',"");
       return false;
   }
   return true;
}

function isFieldString(formname, field, fmt , fieldlabel) {
	var form = document.forms[formname];
	var s = form.elements[field].value;
	var dim=fmt.split(",");
	var minlen = dim[0];
	var maxlen = dim[1];
	var len = s.length;
	if ( len<minlen ) {
         showAlertMessage(fieldlabel,'TooShortString',"["+minlen+"]");
		 form.elements[field].focus();
		 return false;
	} else if ( len>maxlen ) {
         showAlertMessage(fieldlabel,'TooLongString',"["+maxlen+"]");
		 form.elements[field].focus();
		 return false;
	}
	return true;
}



function isFieldInteger(formname, field, ln , fieldlabel) {
  var canBeEmpty = false;
  if (ln.indexOf("?")==0) { 
    ln=parseInt( ln.substring(1) ,10);
    canBeEmpty = true; 
  }
  var form = document.forms[formname];
  var s = form.elements[field].value;
  var len = s.length;
  if (s.charAt(0)== '+' || s.charAt(0)== '-') len-- ;

  if (len==0 && !canBeEmpty) {
    showAlertMessage(fieldlabel,'Empty',"");
    form.elements[field].focus();
    return false;
  } else if (len>0) {
	  if ((!isInteger(s)) || (len > ln)) {
	    showAlertMessage(fieldlabel,'InvalidInteger',"["+ln+"]");
	    form.elements[field].focus();
	    return false;
	  }
  }
  return true;
}

function isFieldFloat(formname, field, fmt, fieldlabel) {
  var canBeEmpty = false;
  if (fmt.indexOf("?")==0) { 
    fmt=fmt.substring(1);
    canBeEmpty = true; 
  }
  var form = document.forms[formname];
  var s = form.elements[field].value;
  var errNo  = 0;
  var point  = false;
  var decpoint=".";
  for(var j=0;j< fmt.length;j++) {
     if (!isDigit(fmt.charAt(j))) { decpoint=fmt.charAt(j); break; }
  }
  var dim=fmt.split(decpoint);
  var i      = dim[0];
  var d      = dim[1];
  var signpos  = 0;
  if (s.length>0 || canBeEmpty) {
    signpos=(s.charAt(0)=='+' || s.charAt(0)=='-');
  } else {
    showAlertMessage(fieldlabel,'Empty',"");
    form.elements[field].focus();
    return false;
  }

  for(j=signpos;j<s.length;j++) {
   c = s.charAt(j);
   if (isDigit(c)) {
     if (point) d--; else i--;
     if (d<0) errNo=1;
     if (i<0) errNo=2;
   } else if (c==decpoint) { // decimal point
     if (point) errNo=3;
     else  point=true;
   } else // default
     errNo=4; // invalid char
   if (errNo) {
     showAlertMessage(fieldlabel,'InvalidFloat',"["+dim[0]+decpoint+dim[1]+"]");
	 form.elements[field].focus();
	 return false;
   }
  }
  return true;
}

function checklen(s1,s2) {
  if (s2.length==2) {
	 if (s1.length!=2) { return false; }
  }	else {
	 val = parseInt(s1,10);
	 if (val<10 && s1.length==2) { return false; }
  }
  return true;
}

function isFieldDate(formname,field, dateformat,fieldlabel) {
  var form = document.forms[formname];
  var s = form.elements[field].value;
  var sep="";
  for(var j=0;j<dateformat.length;j++) {
     if (!isLetter(dateformat.charAt(j))) { sep=dateformat.charAt(j); break; }
  }
  if ( sep=="" ) { showAlertMessage(fieldlabel,'InvalidDateFormat',dateformat); return false; }

  var fvet=dateformat.split(sep);
  if ( fvet.length!=3 ) { showAlertMessage(fieldlabel,'InvalidDateFormat',dateformat);  return false; }

  var dvet=s.split(sep);
  var e=true;
  if (dvet.length!=3 ) {
	e=false;
  } else {
     if (  ( isInteger(dvet[0]) || fvet[0]=="MMM") &&
    	   ( isInteger(dvet[1]) || fvet[1]=="MMM") &&
    	   ( isInteger(dvet[2]) || fvet[2]=="MMM") ) {
		 if (fvet[0]=="dd" || fvet[0]=="d"  ) {
			d=parseInt(dvet[0],10); if (!checklen(dvet[0],fvet[0])) {e=false;}
		 } else if (fvet[1]=="dd" || fvet[1]=="d" ) {
		    d=parseInt(dvet[1],10); if (!checklen(dvet[1],fvet[1])) {e=false;}
		 } else if (fvet[2]=="dd" || fvet[2]=="d" ) {
		    d=parseInt(dvet[2],10); if (!checklen(dvet[2],fvet[2])) {e=false;}
		 } else { showAlertMessage(fieldlabel,'InvalidDateFormat',dateformat);  return false; }
		 if (fvet[0]=="MM" || fvet[0]=="M" ) {
			m=parseInt(dvet[0],10); if (!checklen(dvet[0],fvet[0])) {e=false;}
		 } else if (fvet[1]=="MM" || fvet[1]=="M" ) {
		    m=parseInt(dvet[1],10); if (!checklen(dvet[1],fvet[1])) {e=false;}
		 } else if (fvet[2]=="MM" || fvet[2]=="M" ) {
		    m=parseInt(dvet[2],10); if (!checklen(dvet[2],fvet[2])) {e=false;}
		 } else if ( fvet[0]=="MMM" ) {
			m=0;
		    for (var k=0;k<MonthCol.length;k++) {
		    	if(MonthCol[k].toLowerCase() == dvet[0].toLowerCase() ) { m=k+1; }
		    }
		 } else if ( fvet[1]=="MMM" ) {
			m=0;
		    for (k=0;k<MonthCol.length;k++) {
		    	if(MonthCol[k].toLowerCase() == dvet[1].toLowerCase() ) { m=k+1; }
		    }
		 } else if ( fvet[2]=="MMM" ) {
			m=0;
		    for (k=0;k<MonthCol.length;k++) {
		    	if(MonthCol[k].toLowerCase() == dvet[2].toLowerCase() ) { m=k+1; }
		    }
		 } else { showAlertMessage(fieldlabel,'InvalidDateFormat',dateformat);  return false; }

		 if (fvet[0]=="yyyy" || fvet[0]=="yy") {
			if (fvet[0]=="yyyy") { y=parseInt(dvet[0],10); } else { y=2000+ parseInt(dvet[0],10); }
		 } else if (fvet[1]=="yyyy" || fvet[1]=="yy") {
			if (fvet[1]=="yyyy") { y=parseInt(dvet[1],10); } else { y=2000+ parseInt(dvet[1],10); }
		 } else if (fvet[2]=="yyyy" || fvet[2]=="yy") {
			if (fvet[2]=="yyyy") { y=parseInt(dvet[2],10); } else { y=2000+ parseInt(dvet[2],10); }
		 } else { showAlertMessage(fieldlabel,'InvalidDateFormat',dateformat); return false; }
         if ( y<2000 || y>3000 ) { e=false; }
         if ( m<1    || m>12   ) { e=false; }
         if ( d<1    || d>31   ) { e=false; }

         if (e) {
            v=new Date(m+"/"+d+"/"+y);
            if (v.getMonth()!=m-1) {  e=false; }
         }
    } else { e=false; }
  }
  if (!e) {
     showAlertMessage(fieldlabel,'InvalidDate',"["+dateformat+"]");
  	 form.elements[field].focus();
  	 return false;
  } else {
    return true;
  }
}

function checkRegExpr(formname,field, regexpr,fieldlabel) {
   var form = document.forms[formname];
   var s = form.elements[field].value;
   var re = new RegExp(regexpr);
   var m = re.exec(s);
   if (m == null) {
        showAlertMessage(fieldlabel,'InvalidFieldFormat',"["+regexpr+"]");
	    form.elements[field].focus();
	    return false;
   }
   return true;	
}

function checkRegExpr(formname,field, regexpr,fieldlabel,ignoreCase) {
   var form = document.forms[formname];
   var s = form.elements[field].value;
   if (s=="") { return true; }
   var regex ;
   var strOptions="";
   if (ignoreCase) strOptions+="i";
   try {
	   if ( regexpr == "EMAIL" ) {
		   regex = new RegExp("^((?:(?:(?:[a-zA-Z0-9][\\.\\-\\+_]?)*)[a-zA-Z0-9])+)\\@((?:(?:(?:[a-zA-Z0-9][\\.\\-_]?){0,62})[a-zA-Z0-9])+)\\.([a-zA-Z0-9]{2,6})$",strOptions);
	   } else if ( regexpr == "WEB" ) {
		   regex = new RegExp("^[a-zA-Z0-9\\-\\.]+\\.[a-zA-Z]{2,3}(:[a-zA-Z0-9]*)?/?([a-zA-Z0-9\\-\\._\\?\\,\\'/\\\\\\+&amp;%\\$#\\=~])*[^\\.\\,\\)\\(\\s]$",strOptions);
	   } else if ( regexpr == "URL" ) {
		   regex = new RegExp("^(http|https|ftp)\://[a-zA-Z0-9\\-\\.]+\\.[a-zA-Z]{2,3}(:[a-zA-Z0-9]*)?/?([a-zA-Z0-9\\-\\._\\?\\,\\'/\\\\\\+&amp;%\\$#\\=~])*[^\\.\\,\\)\\(\\s]$",strOptions);
	   } else if ( regexpr == "IP" ) {
		   regex = new RegExp("^((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\\.){3}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})$",strOptions);
	   } else if ( regexpr == "COLOR" ) {
		   regex = new RegExp("^#?([a-f]|[A-F]|[0-9]){3}(([a-f]|[A-F]|[0-9]){3})?$",strOptions);
	   } else if ( regexpr == "PHONE" ) {
		   regex = new RegExp("^(\\+[1-9][0-9]*(\\([0-9]*\\)|[-\\s][0-9]*[-.\\s]))?[0]?[1-9][0-9\\-.\\s]*$",strOptions);
	   } else if ( regexpr == "TIME" ) {
		   regex = new RegExp("^([0-1][0-9]|[2][0-3])(:([0-5][0-9])){1,2}$",strOptions);
	   } else if ( regexpr == "PERC" ) {
		   regex = new RegExp("^(0*100{1,1}\\.?((?<;=\\.)0*)?%?$)|(^0*\\d{0,2}\\.?((?<;=\\.)\\d*)?%?)$",strOptions);
	   } else if ( regexpr == "CREDIT-CARD" ) {
		   regex = new RegExp("^\\d{4}((-\\d{4}){3}$)|((\\d{4}){3}$)",strOptions);
	   } else if ( regexpr == "USERNAME" || regexpr == "PASSWORD" ) {
		   regex = new RegExp("^[a-zA-Z0-9\\-\\._]{3,25}$",strOptions);
	   } else {
		   regex = new RegExp(regexpr,strOptions);
	   }
	   if (!regex.test(s)) {
            showAlertMessage(fieldlabel,'InvalidFieldFormat',"["+regexpr+"]");
		    form.elements[field].focus();
		    return false;
	   }
   } catch (e) { alert("ERROR: "+e);  return false; }
   return true;	
}


function post_to_url(path, params , extra) {
	var form = document.createElement("form");
	form.setAttribute("method", "post");
	form.setAttribute("action", path);
	var addField = function( key, value ){
		var hiddenField = document.createElement("input");
		hiddenField.setAttribute("type", "hidden");
		hiddenField.setAttribute("name", key);
		hiddenField.setAttribute("value", value );
		form.appendChild(hiddenField);
	}; 
	for(var i=0;i<params.length;i++) {
		addField( params[i].key, params[i].value ); 
	}
	if (extra!=null) {
	  for(i=0;i<extra.length;i++) {
		addField( extra[i].key, extra[i].value ); 
	  }
	}
	document.body.appendChild(form);
	form.submit();
}
//####################################################################################

function createXmlHttpRequest() {
    if(window.ActiveXObject) {
        return new ActiveXObject("Msxml2.XMLHTTP");
    } else if(window.XMLHttpRequest) {
        return new XMLHttpRequest();
    }
    return null;
}


function getFormFieldValues(httpform,formname) {
	var params="";
	for (var i = 0; i < document.forms[httpform].elements.length; i++)  {
	   var element=	document.forms[httpform].elements[i];
	   if (element.name.indexOf("OP_")==0) { continue; }
	   if (element.type && element.type!="button" && element.type!="submit" ) {
	     if ( (element.type=="radio" || element.type=="checkbox") && !element.checked ) { continue; }         
		 var dateformat = element.getAttribute("dateformat");
		 var numformat  = element.getAttribute("numformat");
		 if (dateformat) { 		 
			var date = parseDate(element.value,dateformat,"");		
			var d  = date.getDate();
			var day = (d < 10) ? '0' + d : d;
			var m = date.getMonth() + 1;
			var month = (m < 10) ? '0' + m : m;
			if ( params!="" ) { params+="&"; }	
			params+=element.name+"="+date.getFullYear()+ "-" + month + "-" +day ;
	     } else if (numformat && numformat.indexOf(',')>0) {	
			value = element.value.replace(',','!');
			value = value.replace('.',',');
			value = value.replace('!','.');	
			if ( params!="" ) { params+="&"; }	
			params+=element.name+"="+value;
		 } else if ( element.multiple ) {
			 var suffix = "_list";
			 if (document.forms[httpform].elements[element.name+suffix]) {
				 listbox_selectall(element.id,true);
			 } else if ( element.name.indexOf(suffix, this.length - suffix.length) !== -1 ) { continue; }
			 var multiValue="";
			 for (var x=0;x<=element.options.length;x++) {
				if (element.options[x]) {
					if (element.options[x].selected ) {
						if ( multiValue!="" ) multiValue += ",";
						multiValue += encodeURIComponent(element.options[x].value);
					}
	            }
	         }
			 if ( params!="" ) { params+="&"; }	
			 params+=element.name+"="+multiValue;	   
		 } else {
		   if ( params!="" ) { params+="&"; }	
	       params+=element.name+"="+encodeURIComponent(element.value);
		 }
	   }
	}	
	return params;
}

// Sets up the communication with the server.
function submitRequest(httpform,formname) {
  var xmlHttp = createXmlHttpRequest();
  if (xmlHttp!=null) {
	  var params=getFormFieldValues(httpform,formname);
	  xmlHttp.open("POST","../servlet/JRFormValidateServlet",true);
	  xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	  xmlHttp.setRequestHeader("Content-length", params.length);
	  xmlHttp.setRequestHeader("Connection", "close");
	  xmlHttp.onreadystatechange=handleFormSubmit;
	  xmlHttp.send(params);
  }

	function handleFormSubmit() {
	    if(xmlHttp.readyState==4) {
	        if(xmlHttp.status==200) {
	           if ( xmlHttp.responseXML.getElementsByTagName("message")[0].childNodes.length>0 ) {
	        	   alert(xmlHttp.responseXML.getElementsByTagName("message")[0].childNodes[0].nodeValue);
	           } else {
	        	   if (document.forms[httpform]) {
	        		   document.forms[httpform].submit();
	        	   }
	           }
	        } else {
	           alert("Error loading page "+ xmlHttp.status +": "+xmlHttp.statusText);
	        }
	    }
	}
}


function refreshFormPage( httpform , formtype , fieldname ) {
	 try {
		  var docform = document.forms[httpform];
		  docform.action="";
		  docform.elements[formtype].value= "false" ;
		  docform.elements["activefield"].value= fieldname ;
     	  docform.submit();
	 } catch (e) {}
}

function setSelectValues( field, currentvalue , values ) {
	field.length = 1;
	field.selectedIndex  = 0;
	field.options[0] = new Option("","");	
	var cnt = 0 ;
	for (var j=0;j<values.length; j++)  {
		try {			
			range = values[j].split('|');
			displayvalue = range[0];
			if (range.length>1) {
			  datavalue = range[1];				  
			} else {
			  datavalue = range[0];
			}
			if ( j==0 || datavalue!="" ) {
				field.options[cnt] = new Option(displayvalue,datavalue);			
				if ( isSelected( datavalue , currentvalue )) { field.options[cnt].selected=true; }
				cnt++;			
			}
	   } catch (e) {}
	}
}	

function setListValues( field, currentvalue , values ) {
	field.length = 1;
	field.selectedIndex  = 0;
	field.options[0] = new Option("","");	
	var cnt = 0 ;
	for (var k=0;k<2;k++) {
		for (var j=0;j<values.length; j++)  {
			try {
				range = values[j].split('|');
				displayvalue = range[0];
				if (range.length>1) {
				  datavalue = range[1];				  
				} else {
				  datavalue = range[0];
				}
				if ( datavalue!="" && datavalue!="*" ) {
					if (k==0 && isSelected( datavalue, currentvalue)) {
						field.options[cnt] = new Option(displayvalue,datavalue);
						field.options[cnt].selected=true;
						cnt++;
					} else if (k==1 && !isSelected(datavalue, currentvalue)) {
						field.options[cnt] = new Option(displayvalue,datavalue);
						cnt++;
					}				
				}
			} catch (e) {}
		}
	}
}	

function setListBoxValues( field_list, field , currentvalue , values ) {
	field_list.length = 1;
	field_list.selectedIndex  = 0;
	field_list.options[0] = new Option("","");
	field.length = 0;
	var cnt = 0 ;
	var cnt_list = 0 ;
	for (var j=0;j<values.length; j++)  {
		try {				
			range = values[j].split('|');
			displayvalue = range[0];
			if (range.length>1) {
			  datavalue = range[1];				  
			} else {
			  datavalue = range[0];
			}
			if ( datavalue!="" ) {
				if ( isSelected( datavalue , currentvalue )) {
					field.options[cnt] = new Option(displayvalue,datavalue);
					cnt++;
				} else {
					field_list.options[cnt_list] = new Option(displayvalue,datavalue);
					cnt_list++;
				}						
			}
	   } catch (e) {}
	}
}	

function isSelected( key , value ) {
	return ( ","+value+"," ).indexOf( ","+key+",")>= 0;
}

function refreshFieldData( httpform , formname , rangefieldlist , loadfieldlist , fieldname) {

	  var xmlHttp = createXmlHttpRequest();
      if (xmlHttp!=null) {
		  try {
		    if (fieldname!="null") {
			  document.forms[httpform].elements["activefield"].value= fieldname ;
			}
		  } catch (e) {}
		  var params=getFormFieldValues(httpform,formname);
		  params+="&rangefieldlist="+rangefieldlist+"&loadfieldlist="+loadfieldlist;
		  xmlHttp.open("POST","../servlet/JRFormFieldRangeServlet",true);
		  xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		  xmlHttp.setRequestHeader("Content-length", params.length);
		  xmlHttp.setRequestHeader("Connection", "close");
		  xmlHttp.onreadystatechange=handleRefreshData;
		  xmlHttp.send(params);
      }

   function handleRefreshData() {

    if(xmlHttp.readyState==4) {
        if(xmlHttp.status==200) {
           var fieldList = xmlHttp.responseXML.getElementsByTagName("field");
           var editForm = document.forms[httpform];
           //alert( xmlHttp.responseText );
           for (var i=0;i<fieldList.length; i++)  {
         	   var fieldname = fieldList[i].getAttribute('name');	   
         	   var field = editForm.elements[fieldname];			   
         	   var rangelist = fieldList[i].getElementsByTagName("range");
			   
			   // Reset the search operator for current field (if present)
			   var opfield = editForm.elements["OP_"+fieldname];
			   if (opfield && opfield.value=="") { opfield.selectedIndex=1;  }
			   
        	   if ( field && field.type && field.type.indexOf("select")==0 ) {

				  // Get the current selected options
				  var fieldvalue = "";
				  if (field.options) {
				      for (var j=0; j<field.options.length; j++)  {
					    if (field.options[j].selected) {
             	  		   fieldvalue+=field.options[j].value+",";
						}
				  	  }
				  } else { fieldvalue=field.value+","; }
				  
				  var values = new Array();
				  for (var j=0;j<rangelist.length; j++)  {
				    rangeNode = rangelist[j].childNodes[0];
					if (rangeNode) values[j] = rangeNode.nodeValue; else values[j]="";
				  }							 

				  // Load the new ranges and re-select the same values if possible
				  if ( !field.multiple ) {
					 setSelectValues( field , fieldvalue , values );
				  } else if (editForm.elements[fieldname+"_list"] ) {							
					 setListBoxValues( editForm.elements[fieldname+"_list"] , field , fieldvalue , values );
				  } else {
					 setListValues( field , fieldvalue , values );
				  }
				  
               } else if (rangelist.length>0) {
            	  if ( field && field.type ) {
				    var value = rangelist[0].childNodes[0].nodeValue;
					var dateformat = field.getAttribute("dateformat");
		  		    var numformat  = field.getAttribute("numformat");
		            if (dateformat) { 		 
						value = formatDate(value,dateformat,"");					
					} else if (numformat && numformat.indexOf(',')>0) {
						value = value.replace(',','!');
						value = value.replace('.',',');
						value = value.replace('!','.');	
					}
					field.value = value;
            	  } else {
            		for (var i = 0; i < editForm.elements.length; i++)  {
            		  var element = editForm.elements[i];
            		  if ( element.name == fieldname || element.name == fieldname+"[]" ) {
            			  element.checked = false;
            			  for (var j=0;j<rangelist.length; j++)  {
						     rangeNode = rangelist[j].childNodes[0];
					         if (rangeNode) range = rangeNode.nodeValue; else range="";
                             if ( element.value == range ) {
                            	 element.checked = true;
                             }
            			  }
            		  }
            		}
            	  }
               }
           }
           NFFix();
        } else {
           alert("Error loading page "+ xmlHttp.status +": "+xmlHttp.statusText);
        }
    }
  }
}


 function getObjectSelected(formitem,formtable,ndx) {
	var objectlist = "";
	for (var i = 0; i < formitem.elements.length; i++)  {
	  var element =	formitem.elements[i];
	  if (element.type && element.name && element.name.indexOf(formtable+"_")==0 ) {
	    if ( (element.type=="radio" || element.type=="checkbox") && element.checked ) {
		    if (objectlist!="") { objectlist+=","; }
		    if ( element.value.indexOf("/")<0 ) {
		      objectlist+= escape(element.value) ;
		    } else {
		      var sval = element.value.split('/');
		      objectlist+= escape(sval[ndx]) ;
		    }
		}
	  }
	}
	return objectlist;
 }

 function doObjectUnLink(id , formitem , tabName , messageempty , message ){
   try {
    var objectlist = getObjectSelected(formitem,tabName,1);
    if (objectlist!="") {
       if (confirm(message)) {
        var fwd = document.location.href;
        fwd = fwd.substr( fwd.indexOf(applicationRoot) );
        if ( fwd.indexOf("?")>0 ) { fwd = fwd.substr(0,fwd.indexOf("?")); }
        document.location.href=applicationRoot+"common/dowork.jsp?id="+escape(id)+"&action=unlink&list="+objectlist+"&fwd="+fwd;
       }
    } else {
	   alert(messageempty);
	}
   } catch (e) {}
 }

 function doObjectDestroy(id , message , fwd){
   try {
      if (confirm(message)) {		
	    if (window.opener != null) {	      
          document.location.href=applicationRoot+"common/dowork.jsp?id="+escape(id)+"&action=erase&list="+id+"&close=yes";
		  try {
            window.opener.reloadData();
          } catch (e) {}
	    } else {
	      document.location.href=applicationRoot+"common/dowork.jsp?id="+escape(id)+"&action=erase&list="+id+"&fwd="+applicationRoot+"home.jsp";	      
	    }
      }
   } catch (e) {}
 }

 function doObjectErase(id , formitem , tabName , messageempty , message){
   try {
    var objectlist = getObjectSelected(formitem,tabName,0);
    if (objectlist!="") {
       if (confirm(message)) {
         var fwd = document.location.href;
         fwd = fwd.substr( fwd.indexOf(applicationRoot) );
         if ( fwd.indexOf("?")>0 ) { fwd = fwd.substr(0,fwd.indexOf("?")); }
         document.location.href=applicationRoot+"common/dowork.jsp?id="+escape(id)+"&action=erase&list="+objectlist+"&fwd="+fwd;
       }
    } else {
	   alert(messageempty);
	}
   } catch (e) {}
 }

 function doObjectLink(id , formitem , tabName , linktype , versus , fwdpage){
  try {
   var objectlist = getObjectSelected(formitem,tabName,0);
   if (objectlist!="") {
	   if (fwdpage!=null && fwdpage!='null') { objectlist+="&fwd="+fwdpage; }
       document.location.href=applicationRoot+"common/dowork.jsp?close=y&id="+escape(id)+"&action=link&linktype="+linktype+"&versus="+versus+"&list="+objectlist;
   }
  } catch (e) {}
 }
 

 
